#version 330
#extension GL_EXT_gpu_shader4 : enable
//The wall_it breathesMod01.fsh  by  ErnstHot
//https://www.shadertoy.com/view/lsBSzt
// Licence CC0
// Adapted, trivialy, for use in VGHD player
/////////////////////////////////////////////
uniform float u_Elapsed;    // The elapsed time in seconds
uniform vec2  u_WindowSize; // Window dimensions in pixels

#define iTime u_Elapsed*0.314159  //*0.1666
#define iResolution u_WindowSize

//#define mouse AUTO_MOUSE
//#define MOUSE_SPEED vec2(vec2(0.5,0.577777) * 0.25)
//#define MOUSE_POS   vec2((1.0+cos(iTime*MOUSE_SPEED))*u_WindowSize/2.0)
//#define MOUSE_PRESS vec2(0.0,0.0)
//#define AUTO_MOUSE  vec4( MOUSE_POS, MOUSE_PRESS )
//#define RIGID_SCROLL
// alternatively use static mouse definition
#define iMouse vec4(0.0,0.0, 0.0,0.0)
//#define iMouse vec4(512,256,180,120)
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
vec4 texture2D_Fract(sampler2D sampler,vec2 P) {return texture2D(sampler,fract(P));}
vec4 texture2D_Fract(sampler2D sampler,vec2 P, float Bias) {return texture2D(sampler,fract(P),Bias);}
#define texture2D texture2D_Fract

// Ugly code ahead. Yolo.

const float Pi = 3.14159;
const float Pi2 = Pi * 2.0;
const float hPi = Pi * 0.5;
vec3 ct[9]; 

vec3 lookup(const float pos)
{
    float p = fract(pos) * 7.999;
    int i = int(p);
    float f = fract(p);
    vec3 res = vec3(0.0);
    vec3 a = vec3(0.0);
    vec3 b = vec3(0.0);
    
    // This used to be 8 * "if". There if no else.
    
    if (i < 4)
    {
        if (i < 2)
        {
            if (i == 0)
            {
                a = ct[0]; b = ct[1];    
            }
            else
            {
                a = ct[1]; b = ct[2];
            }            
        }
        else
        {
            if (i == 2)
            {
                a = ct[2]; b = ct[3];    
            }
            else
            {
                a = ct[3]; b = ct[4];
            }            
        }    
    }
    else
    {
	    if (i < 6)
        {
            if (i == 4)
            {
                a = ct[4]; b = ct[5];    
            }
            else
            {
                a = ct[5]; b = ct[6];
            }            
        }
        else
        {
            if (i == 6)
            {
                a = ct[6]; b = ct[7];    
            }
            else
            {
                a = ct[7]; b = ct[8];
            }            
        }    
    }
    
	return mix(a, b, f);
}

void main (void)
//void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
// Alternative colors.
/*
	ct[0] = vec3(0.5, 0.0, 0.3);
	ct[1] = vec3(1.0, 0.4, 0.0);
	ct[2] = vec3(1.0, 0.0, 0.3);
	ct[3] = vec3(1.0, 0.6, 0.0);
	ct[4] = vec3(1.0, 0.0, 0.6);
	ct[5] = vec3(1.0, 0.8, 0.0);
	ct[6] = vec3(1.0, 0.4, 0.0);
	ct[7] = vec3(1.0, 0.6, 0.0);
	ct[8] = vec3(0.5, 0.0, 0.3);
*/  
    
	ct[0] = vec3(0.5, 0.0, 0.3);
	ct[1] = vec3(0.3, 0.1, 0.0);
	ct[2] = vec3(1.0, 0.3, 0.0);
	ct[3] = vec3(1.0, 0.6, 0.0);
	ct[4] = vec3(1.0, 0.9, 0.0);
	ct[5] = vec3(1.0, 0.6, 0.0);
	ct[6] = vec3(1.0, 0.3, 0.0);
	ct[7] = vec3(0.3, 0.1, 0.0);
	ct[8] = vec3(0.5, 0.0, 0.3);
     
    float zoomTime = iTime * 0.073;
    
    vec2 uv = gl_FragCoord.xy / iResolution.xy;
	vec2 uvCos = gl_FragCoord.xy / iResolution.xy;
    float aspect = iResolution.x / iResolution.y;
    uv.x = uv.x * aspect;
    
    uvCos.x = -cos(uvCos.x * Pi2) * 0.5 + 0.5;
    uvCos.y = -cos(uvCos.y * Pi2) * 0.5 + 0.5;
    
    float zp = -sin(hPi + zoomTime) * 0.5 + 0.5;
    float s = 0.5 + 8.0 * zp * ((0.8 + uvCos.x * 0.9) + (0.9 + (1.0 - -cos(uvCos.y + iTime)) * 1.3) + (0.9 + (1.0 - -cos(uvCos.x + iTime)) * 1.3) );
    uv.xy *= s;
    uv.x -= s;
    uv.y -= s * 0.5;
      
    
    float x = 0.5 + 0.5 * -cos(uv.x * Pi2 + iTime * 2.0)  * (uvCos.y + 1.0);
    x += 0.25 + 0.25 * -cos((uv.x + iTime * 0.2) * Pi2 * 2.5);
    float y = 0.5 + 0.5 * -cos(uv.y * Pi2);
    float blah = (0.5 + 0.5 * -cos(iTime * 0.134)) * (uv.x + iTime * 0.1);
    y += 0.25 + 1.0 * -cos(blah + uv.y * Pi2 * 0.1);
    
	gl_FragColor = vec4(lookup(x * y * (1.1 - pow(zp, 0.125)) * 4.1 + iTime * 0.001), 1.0);
}
